function OnMsg.ClassesBuilt()
    XTemplates.customWorkplace = PlaceObj("XTemplate", {
        group = "Infopanel Sections",
        id = "customWorkplace",
        PlaceObj("XTemplateGroup", {
            "__context_of_kind",
            "Workplace"
        }, {
            PlaceObj("XTemplateTemplate", {
                "comment",
                "filter workers",
                "__template",
                "InfopanelButton",
                "RolloverText",
				T({
				  990000000001,
				  "被设置为过滤工人的建筑将不会接受不正确专业的工人，除非是手工分配。"
				}),
				"RolloverTitle",
				T({
				  990000000002,
				  "过滤工人"
				}),
				"RolloverHint",
				T({
				  99000000000,
				  "<left_click> 切换设置"
				}),
                "OnPress",
                function(self, gamepad)
                    PlayFX("UIChangePriority")
                    self.context.allow_all_workers = not self.context.allow_all_workers
					ObjModified(self.context)
                end,
				"OnContextUpdate",
				function(self, context)
					if context.allow_all_workers then
						self:SetIcon("UI/Icons/IPButtons/colonist_section.tga")
					else
						self:SetIcon("UI/Icons/IPButtons/colonist_section_active.tga")
					end
				end
            })
        })
    })
    
	
	if (not WorkplaceFilterUILoaded) then
		XTemplates.sectionCustom = PlaceObj('XTemplate', { 
			group = "Infopanel Sections",
			id = "sectionCustom",
			XTemplates.sectionCustom,
			PlaceObj('XTemplateTemplate', {
				'__context_of_kind', "Workplace",
				'__template', "customWorkplace",
			}),
		})
		WorkplaceFilterUILoaded = true
	end
end