return PlaceObj('ModDef', {
	'title', "工作场所过滤器",
	'description', "Tired of letting uneducated people into your factories? Or maybe even more tired of having your well educated engineers tending to the bars instead of making you more electronics? Fear not, the Workplace Filter is here. When the filter is active for a building, the game won't automatically place workers with the wrong specialisation in that building. Of course, you can still assign workers manually just fine, both with and without the correct specialisation.\r\n\r\nToggling the filter will never kick out any workers, it will just prevent the game from assigning new workers with the incorrect specialisation to that building.\r\n\r\nChangelog:\r\n- Fixed an issue where new colonists landing would sometimes make the game freeze\r\n\r\nDevelopment pipeline:\r\n- More customisable filters (traits like martianborn, letting multiple specialisations or nonspecialised into a building and so on)",
	'tags', "Workers, management, specialisations, specializations, filter, workplace",
	'image', "SteamPreviewImage.png",
	'id', "MMj6B8h",
	'steam_id', "1337172830",
	'author', "Kezo",
	'version', 37,
	'lua_revision', 228184,
	'code', {
		"Code/BuildingFilterButton.lua",
		"Code/ChangeWorkplace.lua",
	},
	'saved', 1522167856,
})